import {FC, ReactNode} from 'react';
import Filter from './filter';
import TableList from './table';
import {context, pageContext, searchContext, useContextReducer} from './context';
import {PageProvider, SearchProvider} from '@components';

const DepartmentProvider: FC<{children: ReactNode}> = function({children}) {
  const state = useContextReducer();
  const {Provider} = context;

  return <Provider value={state}>{children}</Provider>;
};

const Department: FC = function() {
  return (
    <DepartmentProvider>
      <SearchProvider context={searchContext}>
        <PageProvider context={pageContext}>
          <section className='content-main'>
            <Filter />
            <TableList />
          </section>
        </PageProvider>
      </SearchProvider>
    </DepartmentProvider>
  );
};

export default Department;
